unit Amb;
// ************************************************************
//   Exemplo de uso de luz Ambiente
//   Maio de 1998 - Disciplina de Computao Grfica
//   Autor : Mrcio Serolli Pinho
//   Email: pinho@inf.pucrs.br
//   URL: www.inf.pucrs.br/cg   
// ************************************************************
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, OGLView,
  OpenGl, OGLClass, OGLCam, OGLLight, OGLCntrl, ExtCtrls;

type
  TForm1 = class(TForm)
    GL1: TOGLView;
    Camera1: TOGLCamera;
    Timer1: TTimer;
    procedure GL1Paint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Angulo:integer;

implementation

{$R *.DFM}
procedure DefineLuz;
const
     // Define a cor da luz ambiente. Preferenciamente, deve ser branca
     // para permitir que todas as cores atribuidas ao objeto possam ser
     // vistas
  LuzAmbient : Array[0..3] of GLfloat = (1.0, 1.0, 1.0, 1.0);

begin
   // Habilita o uso de iluminao
  glEnable(GL_LIGHTING);

  // Ativa o uso da luz ambiente
  glLightModelfv(GL_LIGHT_MODEL_AMBIENT, @LuzAmbient);

  // Ativa o "Color Tracking"
  glEnable(GL_COLOR_MATERIAL);
end;

// Rotina responsvel pela exibio das faces de um cubo
procedure DesenhaCubo;
begin

  glColor3f(0.9,0.6,0);  // define a cor das faces como "amarelo"
  glBegin(GL_POLYGON); // face posterior
    glNormal3f(0,0,1);  // Normal da face
    glVertex3f(10.0, 10.0, 10.0);
    glVertex3f(-10.0, 10.0, 10.0);
    glVertex3f(-10.0, -10.0, 10.0);
    glVertex3f(10.0, -10.0, 10.0);
  glEnd;


  glBegin(GL_POLYGON);  // face frontal
    glNormal3f(0,0,-1);    // Normal da face
    glVertex3f(10.0, 10.0, -10.0);
    glVertex3f(10.0, -10.0, -10.0);
    glVertex3f(-10.0, -10.0, -10.0);
    glVertex3f(-10.0, 10.0, -10.0);
  glEnd;

  glBegin(GL_POLYGON);  //  face lateral esquerda
    glNormal3f(-1,0,0);   // Normal da face
    glVertex3f(-10.0, 10.0, 10.0);
    glVertex3f(-10.0, 10.0, -10.0);
    glVertex3f(-10.0, -10.0, -10.0);
    glVertex3f(-10.0, -10.0, 10.0);
  glEnd;

  glBegin(GL_POLYGON);   //  face lateral direita
    glNormal3f(1,0,0);  // Normal da face
    glVertex3f(10.0, 10.0, 10.0);
    glVertex3f(10.0, -10.0, 10.0);
    glVertex3f(10.0, -10.0, -10.0);
    glVertex3f(10.0, 10.0, -10.0);
  glEnd;

  glBegin(GL_POLYGON);  //  face superior
    glNormal3f(0,1,0);  // Normal da face
    glVertex3f(-10.0, 10.0, -10.0);
    glVertex3f(-10.0, 10.0, 10.0);
    glVertex3f(10.0, 10.0, 10.0);
    glVertex3f(10.0, 10.0, -10.0);
  glEnd;

  glBegin(GL_POLYGON);   //  face inferior
    glNormal3f(0,-1,0);  // Normal da face
    glVertex3f(-10.0, -10.0, -10.0);
    glVertex3f(10.0, -10.0, -10.0);
    glVertex3f(10.0, -10.0, 10.0);
    glVertex3f(-10.0, -10.0, 10.0);
  glEnd;

end;

procedure TForm1.GL1Paint(Sender: TObject);
begin

  DefineLuz;
  glRotatef(Angulo,0,1,0); // Aplica rotao
  DesenhaCubo;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Angulo:= Angulo + 1;
  if Angulo = 360
  then Angulo := 0;
  GL1.InvalidateGL;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Angulo := 45;
end;

end.



